#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Sun Jan 12 15:56:55 2020

@author: Mathilde
"""

import numpy as np

np.array([[1,2,3],[4,5,6]])

### Fait un tableau 2 lignes et 3 colonnes

np.array([[1,2],[3,4],[5,6]])

### Fait un tableau avec 3 colonnes et 2 lignes

A=np.arange(1,7)

### Fait un tableau d'une ligne et 6 colonnes
### remplies avec les chiffres 1 à 6

A.rechape(2,3)

### Redimensionne le tableau A en 2 lignes et 3 colonnes

### Q1

np.zeros((n,p))

### Permet de créer un tableau de n lignes et p colonnes
### contenant uniquement des zéros (flottants)

### Q2

np.ones((n,p))

### Permet de créer un tableau de n lignes et p colonnes
### contenant uniquement des 1 (flottants)

### Q3

np.eye(3,3)

### Crée le tableau identité avec des flottants (1 sur la diago)


### Q4 

np.random.random((n,p))

### Crée un tableau de taille n*p (3 lignes et 2 colonnes) avec des nombres
### aléatoirement choisis entre 0 et 1. 

### Q5 

2*np.ones((3,3))

### renvoie un tableau de taille 3*3 contenant des 2 (au lieu des 1)

### Q6

np.eye(4,k=1)

### le k = 1 permet de décaler la ligne de 1 par rapport à la diagonale du 
### tableau

### Q7

def joli_tableau(n):
    T=np.zeros((n,n),dtype=int)
    for i in range(n-1):
        T=T+(i+1)*np.eye(n,n,(n-i-1),dtype=int)+(n-i-1)*np.eye(n,n,-i-1,dtype=int)
    T=T+n*np.eye(n,n,0,dtype=int)
    return(T)
    
### Q8 
 
B=joli_tableau(4)
B[2,1]
    
### Renvoie la valeur située sur la 2ème ligne (/!\ les indices commencent à 0)
### et la 1ère colonne

### Q9
B[-1,2]

### Renvoie la valeur située sur la dernière ligne et la 2ème colonnes

### Question 10

A=np.matrix([[3,5,-1],[7,1,1],[3,6,-10]])
B=np.matrix([2,-5,0])
B=B.transpose()
x=np.linalg.solve(A,B)

C=np.array([[3,5,-1],[7,1,1],[3,6,-10]])
D=np.array([2,-5,0])
y=np.linalg.solve(A,B)
     
### Pour tester si la solution est exacte : 
np.allclose(np.dot(A,x),B)

### Renvoie True si A*x = B et False sinon 
    

### Question 11
    
import matplotlib.pyplot as plt
x=np.linspace(0,2*np.pi,10)
y=np.sin(x)
plt.plot(x,y,"-+r")
plt.show()    

### Le "-" sert à relier les points. Le "+" sert à dire que les points sont des +
### et le r sert à dire que la courbe est rouge.

### Pour que la courbe soit jolie, il faut plus de points (donc 100 à la place
### de 10 dans np.linspace(0,2*np.pi,100)) et pour qu'elle soit jaune, remplacer
### le "r" par un "y".


import matplotlib.pyplot as plt
x=np.linspace(0,2*np.pi,100)
y=np.sin(x)
plt.plot(x,y,"-+y")
plt.grid()
plt.xlabel('x')
plt.ylabel('sin(x)')
plt.show()

### plt.grid() affiche le quadrillage. plt.xlabel() et plt.ylabel() permettent
### de mettre des noms aux axes


### Q12

x=np.linspace(-1,1,100)
y=np.sqrt(1-x**2)
plt.plot(x,y,"-r",x,-y,"-r")
plt.axis("equal")
plt.grid()
plt.show()



### Cette fonction sert à afficher le cercle trignonométrique


### Q13

t=np.linspace(0,2*np.pi,100)
x=np.exp(1j*t).real
y=np.exp(1j*t).imag
plt.plot(x,y,"-b")
plt.axis("equal")
plt.grid()
plt.show()


### Q14
from scipy import constants
constants.c,constants.h

### c est la vitesse de la lumière dans le vide, h est la constante de Planck


### Q15

from scipy import interpolate
plt.close()

n=5
x=np.linspace(0,1,n)
y=np.random.random(n)

# Création d'une interpolation (deg 2 par morceaux)
F_interpol=interpolate.interp1d(x,y,kind='quadratic')

# Préparation de l'affichage de l'interpolation
xFin=np.linspace(0,1,30)
yFin=F_interpol(xFin)
plt.plot(x,y,"ro",xFin,yFin,"b+-")
plt.show()

### Ce programme crée 5 points d'abscisses comprises entre 0 et 1 et d'ordonnées
### aléatoirement choisies entre 0 et 1. 
### Par interpolation, on crée une fonction qui permet d'inclure ces 5 points
### (F_interpol). On crée ensuite 30 abscisses dans l'intervalle [0,1] et on calcule
### les ordonnées de ces points grâce à la fonction F_interpol. 
### Enfin, on trace (ronds rouges) les 5 points initiaux et les 30 points de 
### l'interpolation (croix + segments bleus)

### Q16

n=5
x=np.linspace(0,1,n)
y=np.random.random(n)

# Création d'une interpolation (deg 2 par morceaux)
F_interpol2=interpolate.interp1d(x,y,kind='cubic')

# Préparation de l'affichage de l'interpolation
xFin=np.linspace(0,1,30)
yFin=F_interpol2(xFin)
plt.plot(x,y,"ro",xFin,yFin,"b-")
plt.show()


### Visualisation simultanée des deux interpolations

n=5
x=np.linspace(0,1,n)
y=np.random.random(n)

# Création d'une interpolation (deg 2 par morceaux)
F_interpol=interpolate.interp1d(x,y,kind='quadratic')
F_interpol2=interpolate.interp1d(x,y,kind='cubic')

# Préparation de l'affichage de l'interpolation
xFin=np.linspace(0,1,30)
yFin=F_interpol(xFin)
yFin2=F_interpol2(xFin)
plt.plot(x,y,"ro",xFin,yFin,"b-",xFin,yFin2,"g-")
plt.show()







